Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Friends | List of all members
Botan::Certificate_Extension Class Referenceabstract

`#include <x509_ext.h>`

Inheritance diagram for Botan::Certificate_Extension:

## Public Member Functions
virtual void | contents_to (Data_Store &subject, Data_Store &issuer) const =0
virtual Certificate_Extension * | copy () const =0
virtual std::string | oid_name () const =0
virtual OID | oid_of () const
virtual void | validate (const X509_Certificate &subject, const X509_Certificate &issuer, const std::vector< std::shared_ptr< const X509_Certificate >> &cert_path, std::vector< std::set< Certificate_Status_Code >> &cert_status, size_t pos)
virtual | ~Certificate_Extension ()=default

## Protected Member Functions
virtual void | decode_inner (const std::vector< uint8_t > &)=0
virtual std::vector< uint8_t > | encode_inner () const =0
virtual bool | should_encode () const

## Friends
class | Extensions

## Detailed Description

X.509 Certificate Extension

Definition at line 27 of file x509_ext.h.

## Constructor & Destructor Documentation

virtual Botan::Certificate_Extension::~Certificate_Extension | ( |  | ) |
| virtual default

## Member Function Documentation

virtual void Botan::Certificate_Extension::contents_to | ( | Data_Store & | subject,
|  | Data_Store & | issuer
| ) |  | const
| pure virtual

virtual Certificate_Extension* Botan::Certificate_Extension::copy | ( |  | ) | const
| pure virtual

Make a copy of this extension

Returns
  copy of this

Implemented in Botan::Cert_Extension::Unknown_Critical_Extension, Botan::Cert_Extension::CRL_Distribution_Points, Botan::Cert_Extension::CRL_ReasonCode, Botan::Cert_Extension::CRL_Number, Botan::Cert_Extension::Authority_Information_Access, Botan::Cert_Extension::Certificate_Policies, Botan::Cert_Extension::Name_Constraints, Botan::Cert_Extension::Extended_Key_Usage, Botan::Cert_Extension::Issuer_Alternative_Name, Botan::Cert_Extension::Subject_Alternative_Name, Botan::Cert_Extension::Authority_Key_ID, Botan::Cert_Extension::Subject_Key_ID, Botan::Cert_Extension::Key_Usage, and Botan::Cert_Extension::Basic_Constraints.

virtual void Botan::Certificate_Extension::decode_inner | ( | const std::vector< uint8_t > & |  | ) |
| protected pure virtual

virtual std::vector<uint8_t> Botan::Certificate_Extension::encode_inner | ( |  | ) | const
| protected pure virtual

Referenced by Botan::Extensions::add(), Botan::Extensions::encode_into(), and Botan::Extensions::replace().

virtual std::string Botan::Certificate_Extension::oid_name | ( |  | ) | const
| pure virtual

Referenced by Botan::Extensions::add(), and oid_of().

OID Botan::Certificate_Extension::oid_of | ( |  | ) | const
| virtual

Returns
  OID representing this extension

Reimplemented in Botan::Cert_Extension::Unknown_Critical_Extension.

Definition at line 76 of file x509_ext.cpp.

References Botan::OIDS::lookup(), and oid_name().

Referenced by Botan::Extensions::add(), Botan::Extensions::encode_into(), and Botan::Extensions::replace().

77 {
78 return OIDS::lookup(oid_name());
79 }
Botan::Certificate_Extension::oid_name
virtual std::string oid_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18

virtual bool Botan::Certificate_Extension::should_encode | ( |  | ) | const
| inline protected virtual

Definition at line 78 of file x509_ext.h.

Referenced by Botan::Extensions::encode_into().

78 { return true; }

void Botan::Certificate_Extension::validate | ( | const X509_Certificate & | subject,
|  | const X509_Certificate & | issuer,
|  | const std::vector< std::shared_ptr< const X509_Certificate >> & | cert_path,
|  | std::vector< std::set< Certificate_Status_Code >> & | cert_status,
|  | size_t | pos
| ) |  |
| virtual

Reimplemented in Botan::Cert_Extension::Unknown_Critical_Extension, and Botan::Cert_Extension::Name_Constraints.

Definition at line 84 of file x509_ext.cpp.

88 {
89 }

## Friends And Related Function Documentation

friend class Extensions
| friend

Definition at line 77 of file x509_ext.h.

The documentation for this class was generated from the following files:

- src/lib/x509/x509_ext.h
- src/lib/x509/x509_ext.cpp